#include <bits/stdc++.h>
typedef int_fast32_t lli;
using namespace std;
signed main()
{
    ios_base::sync_with_stdio(NULL);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string s;
    cin >> s;
    vector<lli> ans(s.size(), 1e5);
    lli b = 0;
    for(lli i = 1; i < s.size(); i++)
        if(s[i] < s[i-1]) ans[b] = i, b = i;
    for(lli i = 0; i < s.size()-1; i++)
        if(s[i] <= s[i+1]) ans[i+1] = ans[i];
    lli q;
    cin >> q;
    vector<vector<lli> > dp(s.size(), vector<lli>(s.size(), 0));
    for(lli l = 0; l < s.size(); l++)
    {
        for(lli r = l; r < s.size(); r++)
        {
            lli L = l, R = r, c = 0;
            while(L <= R)
            {
                c++;
                L = ans[L];
            }
            dp[l][r] = c;
        }
    }
    while(q--)
    {
        lli aa, bb;
        cin >> aa >> bb, aa--, bb--;
        cout << dp[aa][bb] << endl;
    }
}
